﻿using System;
using System.Web.UI;
using System.Web.UI.WebControls;
using Microsoft.SharePoint;
using Microsoft.SharePoint.Administration;

namespace RH.EmptyAdminRecycleBin.CONTROLTEMPLATES.RHEmptyAdminRecycleBin
{
	public partial class EmptyAdminRecycleBin : UserControl
	{
		protected override void CreateChildControls()
		{
			base.CreateChildControls();
			try
			{
				// only show the button, if the second stage recyclebin is shown (on the sitecollection recyclebinpage)
				if (SPContext.Current == null || 
					!Page.Request.Url.AbsolutePath.EndsWith("AdminRecycleBin.aspx", StringComparison.InvariantCultureIgnoreCase) ||
					Page.Request["View"] != "2")
					return;

				// add button via JavaScript
				AddEmptyAllButton();
			}
			catch (Exception ex)
			{
				HandleException(ex);
			}
		}

		private void AddEmptyAllButton()
		{
			// add localized string
			var localized = GetGlobalResourceObject("wss", "recyclebin_emptyrecyclebin");
			ScriptManager.RegisterClientScriptBlock(this, GetType(), "LocalizedString", "var emptyRecycleBin = '" + localized + "';", true);
			// reference jQuery
			ScriptManager.RegisterClientScriptInclude(this, GetType(), "jQuery", "/_layouts/RH.EmptyAdminRecycleBin/jquery-min.js");
			// add button through JavaScript
			ScriptManager.RegisterClientScriptInclude(this, GetType(), "EmptyAdminRecycleBin", "/_layouts/RH.EmptyAdminRecycleBin/EmptyAdminRecycleBin.js");
		}

		private void HandleException(Exception ex)
		{
			try
			{
				UlsLogging.Write(TraceSeverity.Unexpected, ex.ToString());
				Controls.AddAt(Controls.Count, new Label {CssClass = "ms-error", Text = ex.Message});
			}
			catch (Exception e)
			{
				Trace.Write(e.ToString());
				Page.Response.Write(ex.Message);
			}
		}
	}
}
